'use strict';Object.defineProperty(exports,'__esModule',{value:true});var mark=require('mark.js'),rangySelectionsaverestore=require('rangy-selectionsaverestore'),randomcolor=require('randomcolor'),jss$1=require('jss'),rhymeDetector=require('rhyme-detector'),uniqid=require('uniqid');function _interopDefaultLegacy(e){return e&&typeof e==='object'&&'default'in e?e:{'default':e}}var mark__default=/*#__PURE__*/_interopDefaultLegacy(mark);var rangySelectionsaverestore__default=/*#__PURE__*/_interopDefaultLegacy(rangySelectionsaverestore);var randomcolor__default=/*#__PURE__*/_interopDefaultLegacy(randomcolor);var jss__default=/*#__PURE__*/_interopDefaultLegacy(jss$1);var rhymeDetector__default=/*#__PURE__*/_interopDefaultLegacy(rhymeDetector);var uniqid__default=/*#__PURE__*/_interopDefaultLegacy(uniqid);var jss = jss__default['default'].default;





var script = {
  name: 'RhymeHighlight',
  mounted: function mounted() {
    this.markInstance = new mark__default['default'](this.$refs.myInput);
    this.updateHighlights();
    this.colorsSeed = uniqid__default['default']();
  },
  methods: {
    updateHighlights: function updateHighlights() {
      var _this = this;

      var rhymeGroups = rhymeDetector__default['default'](this.$refs.myInput.innerText);
      var colors = randomcolor__default['default']({
        luminosity: 'light',
        count: rhymeGroups.length,
        seed: this.colorsSeed
      });
      var rhymeStyles = {};
      colors.forEach(function (color, i) {
        rhymeStyles["rhyme-group-".concat(i)] = {
          'background-color': color
        };
      });
      var sheet = jss.createStyleSheet(rhymeStyles);
      sheet.attach();
      var savedSel = rangySelectionsaverestore__default['default'].saveSelection();
      this.markInstance.unmark({
        done: function done() {
          rhymeGroups.forEach(function (group, i) {
            return _this.markInstance.mark(group.join(' '), {
              accuracy: {
                value: "exactly",
                limiters: [",", ".", "-", "\"", "'", "!", "?", "_", "@"]
              },
              className: sheet.classes["rhyme-group-".concat(i)]
            });
          });
          rangySelectionsaverestore__default['default'].restoreSelection(savedSel, true);
        }
      });
    }
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        return () => { };
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: () => context._renderStyles(context._styles)
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return (id, style) => addStyle(id, style, context);
}
function addStyle(id, css, context) {
    const group =  css.media || 'default' ;
    const style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        let code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    let css = '';
    for (const key in styles) {
        const style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "myInput",
    staticClass: "rhyme-highlight",
    attrs: {
      "contenteditable": "true"
    },
    on: {
      "input": _vm.updateHighlights
    }
  }, [_vm._ssrNode("\n   At a loss, the fat chat sat on the mat, like a boss.\n")]);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-5c26b38e_0", {
    source: ".rhyme-highlight{display:block;width:400px;margin:25px auto;border:1px solid #ccc;background:#eaeaea;padding:25px}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__ = undefined;
/* module identifier */

var __vue_module_identifier__ = "data-v-5c26b38e";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, createInjectorSSR, undefined);// Import vue component

var install = function installRhymeHighlight(Vue) {
  if (install.installed) return;
  install.installed = true;
  Vue.component('RhymeHighlight', __vue_component__);
}; // Create module definition for Vue.use()


var plugin = {
  install: install
}; // To auto-install on non-es builds, when vue is found
// eslint-disable-next-line no-redeclare

/* global window, global */

{
  var GlobalVue = null;

  if (typeof window !== 'undefined') {
    GlobalVue = window.Vue;
  } else if (typeof global !== 'undefined') {
    GlobalVue = global.Vue;
  }

  if (GlobalVue) {
    GlobalVue.use(plugin);
  }
} // Inject install function into component - allows component
// to be registered via Vue.use() as well as Vue.component()


__vue_component__.install = install; // Export component by default
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = component;
exports.default=__vue_component__;